import { Test, TestingModule } from '@nestjs/testing';
import { getRepositoryToken } from '@nestjs/typeorm';
import { AlbumService } from './album.service';
import { Album } from './album.entity';

const mockAlbum = new Album();

describe('AlbumService', () => {
  let service: AlbumService;

  beforeEach(async () => {
    const module: TestingModule = await Test.createTestingModule({
      providers: [
        AlbumService,
        {
          provide: getRepositoryToken(Album),
          useValue: {
            findAll: jest.fn().mockResolvedValue([mockAlbum]),
            findOneById: jest.fn().mockResolvedValue(mockAlbum),
            create: jest.fn().mockResolvedValue(1),
            update: jest.fn().mockResolvedValue("Album updated successfully"),
            remove: jest.fn().mockResolvedValue(null),
          },
        },
      ]
    }).compile();

    service = module.get<AlbumService>(AlbumService);
  });

  it('should be defined', () => {
    expect(service).toBeDefined();
  });
});
